# coding: utf-8

"""
    Form Service API

    A list of form and Xaas APIs.  This page describes the RESTful APIs for Form Service. The APIs facilitate CRUD operations on the various resources and entities used throughout Form service (Custom Resource , Form Definition etc.) and allow operations on them (creating custom resource type , fetch form status etc.).  Some of the APIs that list collections of resources also support OData like implementation. Below query params can be used across Form and XaaS entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/form-service/api/custom/resource-types?$orderby=name%20DESC```  2. `page`, `size` - page used in conjunction with `size` helps in pagination of resources.      ```/form-service/api/custom/resource-types?page=0&size=20```   # noqa: E501

    OpenAPI spec version: 1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class FormLayoutState(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'readonly_state': 'FormLayoutStateReadonlyState',
        'visibility_state': 'FormLayoutStateVisibilityState'
    }

    attribute_map = {
        'readonly_state': 'readonlyState',
        'visibility_state': 'visibilityState'
    }

    def __init__(self, readonly_state=None, visibility_state=None):  # noqa: E501
        """FormLayoutState - a model defined in Swagger"""  # noqa: E501
        self._readonly_state = None
        self._visibility_state = None
        self.discriminator = None
        if readonly_state is not None:
            self.readonly_state = readonly_state
        if visibility_state is not None:
            self.visibility_state = visibility_state

    @property
    def readonly_state(self):
        """Gets the readonly_state of this FormLayoutState.  # noqa: E501


        :return: The readonly_state of this FormLayoutState.  # noqa: E501
        :rtype: FormLayoutStateReadonlyState
        """
        return self._readonly_state

    @readonly_state.setter
    def readonly_state(self, readonly_state):
        """Sets the readonly_state of this FormLayoutState.


        :param readonly_state: The readonly_state of this FormLayoutState.  # noqa: E501
        :type: FormLayoutStateReadonlyState
        """

        self._readonly_state = readonly_state

    @property
    def visibility_state(self):
        """Gets the visibility_state of this FormLayoutState.  # noqa: E501


        :return: The visibility_state of this FormLayoutState.  # noqa: E501
        :rtype: FormLayoutStateVisibilityState
        """
        return self._visibility_state

    @visibility_state.setter
    def visibility_state(self, visibility_state):
        """Sets the visibility_state of this FormLayoutState.


        :param visibility_state: The visibility_state of this FormLayoutState.  # noqa: E501
        :type: FormLayoutStateVisibilityState
        """

        self._visibility_state = visibility_state

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(FormLayoutState, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FormLayoutState):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
